commit 32c369ff1f4e25b11d22d7171b44297968d29e92
Author: berryc <berryc>
Date:   Sat Jun 26 23:47:01 2010 +0000

    VMS-style native command syntax for fisql, freebcp, and defncopy

diff --git a/Makefile.am b/Makefile.am
index 1ae6503..e9268f1 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1,4 +1,4 @@
-# version $Id: Makefile.am,v 1.47 2010/01/21 08:34:04 freddy77 Exp $
+# version $Id: Makefile.am,v 1.48 2010/06/26 23:47:01 berryc Exp $
 
 ## SUBDIRS determines in which directories automake will generate a Makefile
 ## See also AC_OUTPUT in configure.ac
@@ -9,11 +9,22 @@ ACLOCAL_AMFLAGS = -I m4
 
 VMS	=	vms/config_h.vms \
 		vms/configure.com \
+		vms/edit.c \
 		vms/descrip_mms.template \
 		vms/getpass.c \
 		vms/libodbc.opt \
+		vms/Makefile.am \
 		vms/odbc_driver_axp.opt \
-		vms/README.vms
+		vms/README.vms \
+		vms/vargdefs.h \
+		vms/vmsarg_command_bcp.cld \
+		vms/vmsarg_command_defncopy.cld \
+		vms/vmsarg_command_isql.cld \
+		vms/vmsarg_mapping_bcp.c \
+		vms/vmsarg_mapping_defncopy.c \
+		vms/vmsarg_mapping_isql.c \
+		vms/vmsarg_parse.c
+
 
 EXTRA_DIST = 	$(VMS) interfaces PWD.in BUGS \
 		freetds.conf locales.conf \
diff --git a/src/apps/defncopy.c b/src/apps/defncopy.c
index dd6b021..7cfda75 100644
--- a/src/apps/defncopy.c
+++ b/src/apps/defncopy.c
@@ -87,7 +87,7 @@ int getopt(int argc, const char *argv[], char *optstring);
 #endif
 #endif /* MicrosoftsDbLib */
 
-static char software_version[] = "$Id: defncopy.c,v 1.19 2010/01/11 14:03:20 jklowden Exp $";
+static char software_version[] = "$Id: defncopy.c,v 1.20 2010/06/26 23:47:02 berryc Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifndef MicrosoftsDbLib
@@ -143,6 +143,11 @@ main(int argc, char *argv[])
 	RETCODE erc;
 	int i, nrows;
 
+#ifdef __VMS
+        /* Convert VMS-style arguments to Unix-style */
+        parse_vms_args(&argc, &argv);
+#endif
+
 	/* Initialize db-lib */
 #if _WIN32 && defined(MicrosoftsDbLib)
 	LPCSTR msg = dbinit();	
diff --git a/src/apps/fisql/fisql.c b/src/apps/fisql/fisql.c
index 9e4b512..8ba0189 100644
--- a/src/apps/fisql/fisql.c
+++ b/src/apps/fisql/fisql.c
@@ -268,6 +268,11 @@ main(int argc, char *argv[])
 	int nby;
 	char adash;
 
+#ifdef __VMS
+        /* Convert VMS-style arguments to Unix-style */
+        parse_vms_args(&argc, &argv);
+#endif
+
 	editor = getenv("EDITOR");
 	if (!editor) {
 		editor = getenv("VISUAL");
diff --git a/src/apps/freebcp.c b/src/apps/freebcp.c
index 79bd0bd..84c0965 100644
--- a/src/apps/freebcp.c
+++ b/src/apps/freebcp.c
@@ -50,7 +50,7 @@
 #include <sybdb.h>
 #include "freebcp.h"
 
-static char software_version[] = "$Id: freebcp.c,v 1.53 2010/05/21 14:10:31 freddy77 Exp $";
+static char software_version[] = "$Id: freebcp.c,v 1.54 2010/06/26 23:47:02 berryc Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 void pusage(void);
@@ -74,6 +74,11 @@ main(int argc, char **argv)
 	DBPROCESS *dbproc;
 	int ok = FALSE;
 
+#ifdef __VMS
+        /* Convert VMS-style arguments to Unix-style */
+        parse_vms_args(&argc, &argv);
+#endif
+
 	memset(&params, '\0', sizeof(params));
 
 	params.textsize = 4096;	/* our default text size is 4K */
diff --git a/vms/Makefile.am b/vms/Makefile.am
index 8565315..1260e1c 100644
--- a/vms/Makefile.am
+++ b/vms/Makefile.am
@@ -1,4 +1,8 @@
-EXTRA_DIST = config_h.vms configure.com descrip_mms.template \
-	edit.c getpass.c libodbc.opt odbc_driver_axp.opt README.vms
+EXTRA_DIST = config_h.vms  configure.com edit.c descrip_mms.template \
+		getpass.c libodbc.opt odbc_driver_axp.opt README.vms \
+		vargdefs.h vmsarg_command_bcp.cld vmsarg_command_defncopy.cld \
+		vmsarg_command_isql.cld vmsarg_mapping_bcp.c \
+		vmsarg_mapping_defncopy.c vmsarg_mapping_isql.c \
+		vmsarg_parse.c
 
 clean:
diff --git a/vms/config_h.vms b/vms/config_h.vms
index f727dd6..b122278 100644
--- a/vms/config_h.vms
+++ b/vms/config_h.vms
@@ -1,4 +1,4 @@
-/* $Id: config_h.vms,v 1.10 2009/04/09 01:40:25 jklowden Exp $ */
+/* $Id: config_h.vms,v 1.11 2010/06/26 23:47:02 berryc Exp $ */
 
 /* include/config.h.in.  Generated from configure.ac by autoheader.  */
 /* and edited by hand for VMS */
@@ -346,4 +346,7 @@ char * readpassphrase(const char *, char *, size_t, int);
 #define HAVE_SQLSETPOSIROW 1
 #define TDS_SQLCOLATTRIBUTE_SQLLEN 1
 
+/* Prototype for routine to convert VMS-style arguments to Unix-style. */
+int parse_vms_args(int *argc, char **argv[]);
+
 #endif /* CONFIG_H_LOADED */
diff --git a/vms/descrip_mms.template b/vms/descrip_mms.template
index eb5b760..b92c881 100644
--- a/vms/descrip_mms.template
+++ b/vms/descrip_mms.template
@@ -16,7 +16,7 @@
 # Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 # Boston, MA 02111-1307, USA.
 # 
-# $Id: descrip_mms.template,v 1.15 2010/05/21 14:02:08 freddy77 Exp $
+# $Id: descrip_mms.template,v 1.16 2010/06/26 23:47:02 berryc Exp $
 
 # OpenVMS description file for FreeTDS
 
@@ -293,10 +293,21 @@ $(TDSODBCSHR) : []libtdsodbc$(OLB)
 apps : freebcp$(E) tsql$(E) bsqldb$(E) defncopy$(E) tdspool$(E) fisql$(E)
 	@ continue
 
-freebcp$(E) : [.src.apps]freebcp$(OBJ) []libsybdb$(OLB) []libtds$(OLB)
-	link$(LINKFLAGS)/exe=$(MMS$TARGET) $(MMS$SOURCE),[]libsybdb$(OLB)/library, []libtds$(OLB)/library
+[]vmsarg_parse$(OBJ) : [.vms]vmsarg_parse.c
+       $(CC) $(CFLAGS)/INCLUDE=([.vms],$(CINCLUDE)) $(CDBGFLAGS) $(MMS$SOURCE)
+
+
+freebcp$(E) : [.src.apps]freebcp$(OBJ) []vmsarg_mapping_bcp$(OBJ) []vmsarg_command_bcp$(OBJ) []vmsarg_parse$(OBJ)
+	link$(LINKFLAGS)/exe=$(MMS$TARGET) $(MMS$SOURCE_LIST),[]libsybdb$(OLB)/library, []libtds$(OLB)/library
+
+[.src.apps]freebcp$(OBJ) : [.src.apps]freebcp.c []libsybdb$(OLB) []libtds$(OLB)
+
+[]vmsarg_mapping_bcp$(OBJ) : [.vms]vmsarg_mapping_bcp.c
+       $(CC) $(CFLAGS)/INCLUDE=([.vms],$(CINCLUDE)) $(CDBGFLAGS) $(MMS$SOURCE)
+
+[]vmsarg_command_bcp$(OBJ) : [.vms]vmsarg_command_bcp.cld
+       SET COMMAND/OBJECT=$(MMS$TARGET) $(MMS$SOURCE)
 
-[.src.apps]freebcp$(OBJ) : [.src.apps]freebcp.c
 
 tsql$(E) : [.src.apps]tsql$(OBJ) []libsybdb$(OLB) []libtds$(OLB)
 	link$(LINKFLAGS)/exe=$(MMS$TARGET) $(MMS$SOURCE),[]libsybdb$(OLB)/library, []libtds$(OLB)/library
@@ -305,24 +316,34 @@ tsql$(E) : [.src.apps]tsql$(OBJ) []libsybdb$(OLB) []libtds$(OLB)
 	@ define/nolog/user_mode readline [.include]
 	$(CC) $(CFLAGS)/INCLUDE=($(CINCLUDE)) $(MMS$SOURCE)
 
+
 bsqldb$(E) : [.src.apps]bsqldb$(OBJ) []libsybdb$(OLB) []libtds$(OLB)
 	link$(LINKFLAGS)/exe=$(MMS$TARGET) $(MMS$SOURCE),[]libsybdb$(OLB)/library, []libtds$(OLB)/library
 
 [.src.apps]bsqldb$(OBJ) : [.src.apps]bsqldb.c
 
-defncopy$(E) : [.src.apps]defncopy$(OBJ) []libsybdb$(OLB) []libtds$(OLB)
-	link$(LINKFLAGS)/exe=$(MMS$TARGET) $(MMS$SOURCE),[]libsybdb$(OLB)/library, []libtds$(OLB)/library
 
-[.src.apps]defncopy$(OBJ) : [.src.apps]defncopy.c
+defncopy$(E) : [.src.apps]defncopy$(OBJ) []vmsarg_mapping_defncopy$(OBJ) []vmsarg_command_defncopy$(OBJ) []vmsarg_parse$(OBJ)
+	link$(LINKFLAGS)/exe=$(MMS$TARGET) $(MMS$SOURCE_LIST),[]libsybdb$(OLB)/library, []libtds$(OLB)/library
+ 
+[.src.apps]defncopy$(OBJ) : [.src.apps]defncopy.c []libsybdb$(OLB) []libtds$(OLB)
+
+[]vmsarg_mapping_defncopy$(OBJ) : [.vms]vmsarg_mapping_defncopy.c
+       $(CC) $(CFLAGS)/INCLUDE=([.vms],$(CINCLUDE)) $(CDBGFLAGS) $(MMS$SOURCE)
+
+[]vmsarg_command_defncopy$(OBJ) : [.vms]vmsarg_command_defncopy.cld
+       SET COMMAND/OBJECT=$(MMS$TARGET) $(MMS$SOURCE)
+
 
 tdspool$(E) : $(TDSPOOLOBJS) []libtdssrv$(OLB) []libtds$(OLB)
 	link$(LINKFLAGS)/exe=$(MMS$TARGET) $(TDSPOOLOBJS), []libtdssrv$(OLB)/library, []libtds$(OLB)/library
 
 
-fisql$(E) : [.src.apps.fisql]fisql$(OBJ) [.src.apps.fisql]interrupt$(OBJ) [.src.apps.fisql]handlers$(OBJ) [.vms]edit$(OBJ)
-	link$(LINKFLAGS)/exe=$(MMS$TARGET) $(MMS$SOURCE_LIST),[]libsybdb$(OLB)/library, []libtds$(OLB)/library
-
-[.src.apps.fisql]fisql$(OBJ) : [.src.apps.fisql]fisql.c
+fisql$(E) : [.src.apps.fisql]fisql$(OBJ) [.src.apps.fisql]interrupt$(OBJ) [.src.apps.fisql]handlers$(OBJ) [.vms]edit$(OBJ) \
+    []vmsarg_mapping_isql$(OBJ) []vmsarg_command_isql$(OBJ) []vmsarg_parse$(OBJ)
+ 	link$(LINKFLAGS)/exe=$(MMS$TARGET) $(MMS$SOURCE_LIST),[]libsybdb$(OLB)/library, []libtds$(OLB)/library
+ 
+[.src.apps.fisql]fisql$(OBJ) : [.src.apps.fisql]fisql.c []libsybdb$(OLB) []libtds$(OLB)
 	@ define/nolog/user_mode readline [.include]
 	$(CC) $(CFLAGS)/INCLUDE=($(CINCLUDE)) $(MMS$SOURCE)
 
@@ -330,6 +351,11 @@ fisql$(E) : [.src.apps.fisql]fisql$(OBJ) [.src.apps.fisql]interrupt$(OBJ) [.src.
 
 [.src.apps.fisql]handlers$(OBJ) : [.src.apps.fisql]handlers.c
 
+[]vmsarg_mapping_isql$(OBJ) : [.vms]vmsarg_mapping_isql.c
+       $(CC) $(CFLAGS)/INCLUDE=([.vms],$(CINCLUDE)) $(CDBGFLAGS) $(MMS$SOURCE)
+
+[]vmsarg_command_isql$(OBJ) : [.vms]vmsarg_command_isql.cld
+       SET COMMAND/OBJECT=$(MMS$TARGET) $(MMS$SOURCE)
 
 # Run the test suite
 
diff --git a/vms/vargdefs.h b/vms/vargdefs.h
new file mode 100644
index 0000000..a75adc9
--- /dev/null
+++ b/vms/vargdefs.h
@@ -0,0 +1,70 @@
+/* FreeTDS - Library of routines accessing Sybase and Microsoft databases
+ * Copyright (C) 2010  Craig A. Berry	craigberry@mac.com
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public
+ * License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+
+/*
+ * Definitions used by the VMSARG parsing and mapping routines.
+ *
+ * Based on VMSARG Version 2.0 by Tom Wade <t.wade@vms.eurokom.ei>
+ *
+ * Extensively revised for inclusion in FreeTDS by Craig A. Berry.
+ *
+ * From the VMSARG 2.0 documentation:
+ *
+ * The product is aimed at . . . people who are porting a package from 
+ * Unix to VMS. This software is made freely available for inclusion in 
+ * such products, whether they are freeware, public domain or commercial. 
+ * No licensing is required.
+ */
+
+#if __CRTL_VER >= 70302000 && !defined(__VAX)
+#define QUAL_LENGTH		(4000+1)
+#define S_LENGTH		(4096+1)
+#else
+#define QUAL_LENGTH		(255+1)
+#define S_LENGTH		(1024+1)
+#endif
+
+#define MAX_ARGS 255
+
+/*	bit fields for arg flags.
+*/
+
+#define VARG_M_AFFIRM		 1
+#define VARG_M_NEGATIVE		 2
+#define VARG_M_KEYWORDS		 4
+#define VARG_M_SEPARATOR	 8
+#define VARG_M_DATE		16
+#define VARG_M_APPEND		32
+#define VARG_M_HELP		64
+
+/*	bit fields for action flags.
+*/
+
+#define VARGACT_M_UPPER		1
+#define VARGACT_M_LOWER		2
+#define VARGACT_M_SPECIAL	4
+#define VARGACT_M_ESCAPE	8
+#define VARGACT_M_DOUBLE	16
+#define VARGACT_M_IMAGE		32
+#define VARGACT_M_SYMBOL	64
+#define VARGACT_M_COMMAND	128
+#define VARGACT_M_RETURN	256
+#define VARGACT_M_PROTECT	512
+#define VARGACT_M_UNIXARG	1024
+
+#define VARGACT_M_PROTMASK	1+2+4+8+16
diff --git a/vms/vmsarg_command_bcp.cld b/vms/vmsarg_command_bcp.cld
new file mode 100644
index 0000000..6872e2b
--- /dev/null
+++ b/vms/vmsarg_command_bcp.cld
@@ -0,0 +1,92 @@
+! FreeTDS - Library of routines accessing Sybase and Microsoft databases
+! Copyright (C) 2010  Craig A. Berry	craigberry@mac.com
+!
+! This library is free software; you can redistribute it and/or
+! modify it under the terms of the GNU Library General Public
+! License as published by the Free Software Foundation; either
+! version 2 of the License, or (at your option) any later version.
+!
+! This library is distributed in the hope that it will be useful,
+! but WITHOUT ANY WARRANTY; without even the implied warranty of
+! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+! Library General Public License for more details.
+!
+! You should have received a copy of the GNU Library General Public
+! License along with this library; if not, write to the
+! Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+! Boston, MA 02111-1307, USA.
+
+! Command definitions for the BCP command.
+
+
+Module VARG_CLD
+
+Define Verb VARG
+   parameter P1, label=TABLE_NAME
+      value (required)
+   parameter P2, label=DIRECTION
+      value (required,type=DIR_KEYS)
+   parameter P3, label=DATA_FILE
+      value (required,type=$file)
+   qualifier MAX_ERRORS
+      value (required,type=$number)
+   qualifier FORMAT_FILE
+      value (required,type=$file)
+   qualifier ERRORFILE
+      value (required,type=$file)
+   qualifier FIRST_ROW
+      value (required,type=$number)
+   qualifier LAST_ROW
+      value (required,type=$number)
+   qualifier BATCH_SIZE
+      value (required,type=$number)
+   qualifier NATIVE_DEFAULT
+   qualifier CHARACTER_DEFAULT
+   qualifier COLUMN_TERMINATOR
+      value (required)
+   qualifier ROW_TERMINATOR
+      value (required)
+   qualifier USERNAME
+      value
+   qualifier PASSWORD
+      value (default="")
+   qualifier SERVER_NAME
+      value (required)
+   qualifier INPUT
+      value (required,type=$file)
+   qualifier OUTPUT
+      value (required,type=$file)
+   qualifier SERVCHARSET
+      value
+   qualifier CLIENTCHARSET
+      value
+   qualifier DISPCHARSET
+      value
+   qualifier FILECHARSET
+      value
+   qualifier LANGUAGE
+      value
+   qualifier FILECHARSET
+      value
+   qualifier TDSPACKETSIZE
+      value (type=$number)
+   qualifier TEXTSIZE
+      value (type=$number)
+   qualifier VERSION, syntax=NOPARAM
+   qualifier HOMEDIR
+      value
+   qualifier ENCRYPT
+   qualifier IDENTITY
+   disallow (NATIVE_DEFAULT and CHARACTER_DEFAULT)
+
+define type DIR_KEYS
+   keyword IN
+   keyword OUT
+
+define syntax NOPARAM
+   parameter P1, label=TABLE_NAME
+   parameter P2, label=DIRECTION
+      value (type=DIR_KEYS)
+   parameter P3, label=DATA_FILE
+      value (type=$file)
+
diff --git a/vms/vmsarg_command_defncopy.cld b/vms/vmsarg_command_defncopy.cld
new file mode 100644
index 0000000..0569eed
--- /dev/null
+++ b/vms/vmsarg_command_defncopy.cld
@@ -0,0 +1,65 @@
+! FreeTDS - Library of routines accessing Sybase and Microsoft databases
+! Copyright (C) 2010  Craig A. Berry	craigberry@mac.com
+!
+! This library is free software; you can redistribute it and/or
+! modify it under the terms of the GNU Library General Public
+! License as published by the Free Software Foundation; either
+! version 2 of the License, or (at your option) any later version.
+!
+! This library is distributed in the hope that it will be useful,
+! but WITHOUT ANY WARRANTY; without even the implied warranty of
+! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+! Library General Public License for more details.
+!
+! You should have received a copy of the GNU Library General Public
+! License along with this library; if not, write to the
+! Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+! Boston, MA 02111-1307, USA.
+
+! Command definitions for the DEFNCOPY command.
+
+Module VARG_CLD
+
+define verb VARG
+   parameter P1, label=DIRECTION
+      value (required,type=DIR_KEYS)
+   parameter P2, label=FILE_NAME
+      value (required,type=$file)
+   parameter P3, label=DATABASE_NAME
+      value (required)
+   parameter P4, label=OBJECT_NAME
+      value (list)
+   qualifier USERNAME
+      value
+   qualifier PASSWORD
+      value (default="")
+   qualifier SERVER_NAME, label=SERVERNAME
+      value
+   qualifier VERSION, syntax=NOPARAM
+   qualifier INTERFACES, label=INTERFACE
+      value (type=$file)
+   qualifier DISPCHARSET
+      value
+   qualifier LANGUAGE
+      value
+   qualifier SERVCHARSET
+      value
+   qualifier CLIENTCHARSET
+      value
+   qualifier REAL_VERSION
+   qualifier HOMEDIR
+      value
+
+define type DIR_KEYS
+   keyword IN
+   keyword OUT
+
+define syntax NOPARAM
+   parameter P1, label=DIRECTION
+      value (type=DIR_KEYS)
+   parameter P2, label=FILE_NAME
+      value (type=$file)
+   parameter P3, label=DATABASE_NAME
+   parameter P4, label=OBJECT_NAME
+      value (list)
+
diff --git a/vms/vmsarg_command_isql.cld b/vms/vmsarg_command_isql.cld
new file mode 100644
index 0000000..b31a975
--- /dev/null
+++ b/vms/vmsarg_command_isql.cld
@@ -0,0 +1,79 @@
+! FreeTDS - Library of routines accessing Sybase and Microsoft databases
+! Copyright (C) 2010  Craig A. Berry	craigberry@mac.com
+!
+! This library is free software; you can redistribute it and/or
+! modify it under the terms of the GNU Library General Public
+! License as published by the Free Software Foundation; either
+! version 2 of the License, or (at your option) any later version.
+!
+! This library is distributed in the hope that it will be useful,
+! but WITHOUT ANY WARRANTY; without even the implied warranty of
+! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+! Library General Public License for more details.
+!
+! You should have received a copy of the GNU Library General Public
+! License along with this library; if not, write to the
+! Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+! Boston, MA 02111-1307, USA.
+
+! Command definitions for the ISQL command.
+
+Module VARG_CLD
+
+Define Verb VARG
+   qualifier ECHO
+   qualifier STATISTICS
+   qualifier NOPROMPT
+   qualifier TERMINATOR
+      value
+   qualifier WIDTH
+      value (type=$number)
+   qualifier COLSEPARATOR
+      value
+   qualifier ROWSINPAGE
+      value (type=$number)
+   qualifier TIMEOUT
+      value
+   qualifier ERRORLEVEL
+      value (type=$number)
+   qualifier USERNAME
+      value
+   qualifier PASSWORD
+      value
+   qualifier SERVER_NAME
+      value
+   qualifier INTERFACE
+      value (type=$file)
+   qualifier HOSTNAME
+      value
+   qualifier CLIENTCHARSET
+      value
+   qualifier DISPCHARSET
+      value
+   qualifier INPUT
+      value (type=$file)
+   qualifier OUTPUT
+      value (type=$file)
+   qualifier LANGUAGE
+      value
+   qualifier HOMEDIR
+      value
+   qualifier VERSION
+   qualifier DEBUG
+   qualifier BROWSE
+   qualifier RECORD_FRONT_TO_SERVER
+      value
+   qualifier LOGINTIME
+      value
+   qualifier EDITOR
+      value
+   qualifier TDSPACKETSIZE
+      value (type=$number)
+   qualifier TRACE
+      value
+   qualifier ADDID
+   qualifier LOOK3
+   qualifier ENCRYPT
+   qualifier CHAIN_XACT
+   qualifier FIPS
+define syntax NOPARAM
diff --git a/vms/vmsarg_mapping_bcp.c b/vms/vmsarg_mapping_bcp.c
new file mode 100644
index 0000000..82ef349
--- /dev/null
+++ b/vms/vmsarg_mapping_bcp.c
@@ -0,0 +1,136 @@
+/* FreeTDS - Library of routines accessing Sybase and Microsoft databases
+ * Copyright (C) 2010  Craig A. Berry	craigberry@mac.com
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public
+ * License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+
+/*
+ * Mapping table for the BCP command.
+ */
+
+int vmsarg_mapping (int *nvargs, char *vms_arg[], char *unix_arg[],
+	char *unix_narg[], char *vms_key[], char *unix_key[],
+	char *separator[], int flags[], char *pattern[],
+	char **outverb, int *action_flags, char **arg_symbol,
+	char **image_name)
+{
+ *nvargs = 26;
+ *action_flags = 1301;
+ vms_arg[1] = "TABLE_NAME";
+ flags[1] = 1;
+ unix_arg[1] = "$";
+
+ vms_arg[2] = "DIRECTION";
+ flags[2] = 1;
+ unix_arg[2] = "$";
+
+ vms_arg[3] = "DATA_FILE";
+ flags[3] = 1;
+ unix_arg[3] = "$";
+
+ vms_arg[4] = "MAX_ERRORS";
+ flags[4] = 1;
+ unix_arg[4] = "-m";
+
+ vms_arg[5] = "FORMAT_FILE";
+ flags[5] = 1;
+ unix_arg[5] = "-f";
+
+ vms_arg[6] = "ERRORFILE";
+ flags[6] = 1;
+ unix_arg[6] = "-e";
+
+ vms_arg[7] = "FIRST_ROW";
+ flags[7] = 1;
+ unix_arg[7] = "-F";
+
+ vms_arg[8] = "LAST_ROW";
+ flags[8] = 1;
+ unix_arg[8] = "-L";
+
+ vms_arg[9] = "BATCH_SIZE";
+ flags[9] = 1;
+ unix_arg[9] = "-b";
+
+ vms_arg[10] = "NATIVE_DEFAULT";
+ flags[10] = 1;
+ unix_arg[10] = "-n";
+
+ vms_arg[11] = "CHARACTER_DEFAULT";
+ flags[11] = 1;
+ unix_arg[11] = "-c";
+
+ vms_arg[12] = "COLUMN_TERMINATOR";
+ flags[12] = 1;
+ unix_arg[12] = "-t";
+
+ vms_arg[13] = "ROW_TERMINATOR";
+ flags[13] = 1;
+ unix_arg[13] = "-r";
+
+ vms_arg[14] = "USERNAME";
+ flags[14] = 1;
+ unix_arg[14] = "-U";
+
+ vms_arg[15] = "PASSWORD";
+ flags[15] = 1;
+ unix_arg[15] = "-P";
+
+ vms_arg[16] = "SERVER_NAME";
+ flags[16] = 1;
+ unix_arg[16] = "-S";
+
+ vms_arg[17] = "INPUT";
+ flags[17] = 1;
+ unix_arg[17] = "-i";
+
+ vms_arg[18] = "OUTPUT";
+ flags[18] = 1;
+ unix_arg[18] = "-o";
+
+ vms_arg[19] = "TDSPACKETSIZE";
+ flags[19] = 1;
+ unix_arg[19] = "-A";
+
+ vms_arg[20] = "TEXTSIZE";
+ flags[20] = 1;
+ unix_arg[20] = "-T";
+
+ vms_arg[21] = "VERSION";
+ flags[21] = 1;
+ unix_arg[21] = "-v";
+
+ vms_arg[22] = "DISPCHARSET";
+ flags[22] = 1;
+ unix_arg[22] = "-a";
+
+ vms_arg[23] = "LANGUAGE";
+ flags[23] = 1;
+ unix_arg[23] = "-z";
+
+ vms_arg[24] = "CLIENTCHARSET";
+ flags[24] = 1;
+ unix_arg[24] = "-J";
+
+ vms_arg[25] = "IDENTITY";
+ flags[25] = 1;
+ unix_arg[25] = "-E";
+
+ vms_arg[26] = "ENCRYPT";
+ flags[26] = 1;
+ unix_arg[26] = "-X";
+
+ return 1;
+}
diff --git a/vms/vmsarg_mapping_defncopy.c b/vms/vmsarg_mapping_defncopy.c
new file mode 100644
index 0000000..289b75c
--- /dev/null
+++ b/vms/vmsarg_mapping_defncopy.c
@@ -0,0 +1,80 @@
+/* FreeTDS - Library of routines accessing Sybase and Microsoft databases
+ * Copyright (C) 2010  Craig A. Berry	craigberry@mac.com
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public
+ * License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+
+/*
+ * Mapping table for the DEFNCOPY command.
+ */
+
+int vmsarg_mapping (int *nvargs, char *vms_arg[], char *unix_arg[],
+	char *unix_narg[], char *vms_key[], char *unix_key[],
+	char *separator[], int flags[], char *pattern[],
+	char **outverb, int *action_flags, char **arg_symbol,
+	char **image_name)
+{
+ *nvargs = 12;
+ *action_flags = 1301;
+ vms_arg[1] = "DIRECTION";
+ flags[1] = 1;
+ unix_arg[1] = "$";
+
+ vms_arg[2] = "FILE_NAME";
+ flags[2] = 1;
+ unix_arg[2] = "$";
+
+ vms_arg[3] = "DATABASE_NAME";
+ flags[3] = 1;
+ unix_arg[3] = "$";
+
+ vms_arg[4] = "OBJECT_NAME";
+ flags[4] = 1;
+ unix_arg[4] = "$";
+
+ vms_arg[5] = "USERNAME";
+ flags[5] = 1;
+ unix_arg[5] = "-U";
+
+ vms_arg[6] = "PASSOWRD";
+ flags[6] = 1;
+ unix_arg[6] = "-P";
+
+ vms_arg[7] = "SERVER_NAME";
+ flags[7] = 1;
+ unix_arg[7] = "-S";
+
+ vms_arg[8] = "VERSION";
+ flags[8] = 1;
+ unix_arg[8] = "-v";
+
+ vms_arg[9] = "INTERFACES";
+ flags[9] = 1;
+ unix_arg[9] = "-I";
+
+ vms_arg[10] = "DISPCHARSET";
+ flags[10] = 1;
+ unix_arg[10] = "-a";
+
+ vms_arg[11] = "LANGUAGE";
+ flags[11] = 1;
+ unix_arg[11] = "-z";
+
+ vms_arg[12] = "CLIENTCHARSET";
+ flags[12] = 1;
+ unix_arg[12] = "-J";
+
+ return 1;
+}
diff --git a/vms/vmsarg_mapping_isql.c b/vms/vmsarg_mapping_isql.c
new file mode 100644
index 0000000..19ff256
--- /dev/null
+++ b/vms/vmsarg_mapping_isql.c
@@ -0,0 +1,143 @@
+/* FreeTDS - Library of routines accessing Sybase and Microsoft databases
+ * Copyright (C) 2010  Craig A. Berry	craigberry@mac.com
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public
+ * License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+
+/*
+ * Mapping table for the ISQL command.
+ */
+
+#include <stdlib.h>
+
+int vmsarg_mapping (int *nvargs, char *vms_arg[], char *unix_arg[],
+	char *unix_narg[], char *vms_key[], char *unix_key[],
+	char *separator[], int flags[], char *pattern[],
+	char **outverb, int *action_flags, char **arg_symbol,
+	char **image_name)
+{
+ *nvargs = 26;
+ *action_flags = 1301;
+ vms_arg[1] = "USERNAME";
+ flags[1] = 1;
+ unix_arg[1] = "-U";
+
+ vms_arg[2] = "PASSWORD";
+ flags[2] = 1;
+ unix_arg[2] = "-P";
+
+ vms_arg[3] = "SERVER_NAME";
+ flags[3] = 1;
+ unix_arg[3] = "-S";
+
+ vms_arg[4] = "TIMEOUT";
+ flags[4] = 1;
+ unix_arg[4] = "-t";
+
+ vms_arg[5] = "INPUT";
+ flags[5] = 1;
+ unix_arg[5] = "-i";
+
+ vms_arg[6] = "OUTPUT";
+ flags[6] = 1;
+ unix_arg[6] = "-o";
+
+ vms_arg[7] = "VERSION";
+ flags[7] = 1;
+ unix_arg[7] = "-v";
+
+ vms_arg[8] = "ECHO";
+ flags[8] = 1;
+ unix_arg[8] = "-e";
+
+ vms_arg[9] = "FIPS";
+ flags[9] = 1;
+ unix_arg[9] = "-F";
+
+ vms_arg[10] = "STATISTICS";
+ flags[10] = 1;
+ unix_arg[10] = "-p";
+
+ vms_arg[11] = "NOPROMPT";
+ flags[11] = 1;
+ unix_arg[11] = "-n";
+
+ vms_arg[12] = "ENCRYPT";
+ flags[12] = 1;
+ unix_arg[12] = "-X";
+
+ vms_arg[13] = "CHAIN_XACT";
+ flags[13] = 1;
+ unix_arg[13] = "-Y";
+
+ vms_arg[14] = "DISPCHARSET";
+ flags[14] = 1;
+ unix_arg[14] = "-a";
+
+ vms_arg[15] = "TDSPACKETSIZE";
+ flags[15] = 1;
+ unix_arg[15] = "-A";
+
+ vms_arg[16] = "TERMINATOR";
+ flags[16] = 1;
+ unix_arg[16] = "-c";
+
+ vms_arg[17] = "EDITOR";
+ flags[17] = 1;
+ unix_arg[17] = "-E";
+
+ vms_arg[18] = "ROWSINPAGE";
+ flags[18] = 1;
+ unix_arg[18] = "-h";
+
+ vms_arg[19] = "HOSTNAME";
+ flags[19] = 1;
+ unix_arg[19] = "-H";
+
+ vms_arg[20] = "INTERFACE";
+ flags[20] = 1;
+ unix_arg[20] = "-I";
+
+ vms_arg[21] = "CLIENTCHARSET";
+ flags[21] = 1;
+ unix_arg[21] = "-J";
+
+ vms_arg[22] = "ERRORLEVEL";
+ flags[22] = 1;
+ unix_arg[22] = "-m";
+
+ vms_arg[23] = "LOGINTIME";
+ flags[23] = 1;
+ unix_arg[23] = "-l";
+
+ vms_arg[24] = "COLSEPARATOR";
+ flags[24] = 1;
+ unix_arg[24] = "-s";
+
+ vms_arg[25] = "WIDTH";
+ flags[25] = 1;
+ unix_arg[25] = "-w";
+
+ vms_arg[26] = "LANGUAGE";
+ flags[26] = 1;
+ unix_arg[26] = "-z";
+
+ /* Because vi is not a reasonable default on VMS.
+  */
+ if (setenv("EDITOR", "edit", 0) != 0)
+	return 0;
+
+ return 1;
+}
